//-----------------------------------------------------------------------------
//		Import DLL Region
//-----------------------------------------------------------------------------
#import "libmysql.dll"
int mysql_init(int db);
int mysql_errno(int TMYSQL);
int mysql_real_connect(int TMYSQL, string host, string user, string password, 
                       string DB,int port,int socket,int clientflag);
int mysql_real_query(int TMSQL, string query, int length);
void mysql_close(int TMSQL);
#import
//-----------------------------------------------------------------------------
//		Global Variables
//-----------------------------------------------------------------------------
int mysql;	//  , connection ID
string query = "";
int length = 0;
int myerr = 0;
int Prev_Minute = 0;

string host = "localhost";
string user = "root";
string password = "123";
string DB = "mt4";		//    
int clientflag = 0;
int port = 3306;
string socket = "";

int res;
int err;
string Table = "";
//-----------------------------------------------------------------------------
//		Extern Parameters
//-----------------------------------------------------------------------------
extern int Per = 1;	//    
//-----------------------------------------------------------------------------
int init()
{
	if( Period() != Per )
	{
		Alert( "Modify the chart interval to ", Per, " minutes." );
		return(0);
	}
//		     ,   - 
//		   { Key	Date	Open	High	Low	Close }

	mysql = mysql_init( mysql );
	if( mysql != 0 )
	{
		Print( "allocated" );
//		Alert("Init connectio ID granted");
	}
	res = mysql_real_connect( mysql, host, user, password, DB, port, socket, clientflag );
	err = GetLastError();
	if( res == mysql )
	{
		Print( "connected" );
		Alert("Connection ID", mysql );
	}
	else
		Alert( "DB connection error=", mysql, " ", mysql_errno(mysql), " " );

	Table = StringConcatenate( Symbol(), Period()  );
	query = StringConcatenate( "CREATE TABLE IF NOT EXISTS ", Table,
		"( key_ptr SERIAL, date DATETIME, open FLOAT, high FLOAT, low FLOAT, close FLOAT )" );
	length = StringLen(query);
	mysql_real_query(mysql, query, length);
	myerr = mysql_errno(mysql);
	if(myerr > 0)
		Alert("Create table ", Table, " error=", myerr);

	return(0);
}
//-----------------------------------------------------------------------------
int deinit()
{
//		  .
	mysql_close(mysql);
	return(0);
}
//-----------------------------------------------------------------------------
int start()
{
	int Cur_Minute = Minute();
//		   
	if( Cur_Minute != Prev_Minute && MathMod( ( Cur_Minute - Prev_Minute), Per) == 0 )
	{
		Prev_Minute = Cur_Minute;
//		 ...		
		query = StringConcatenate( "Select max( key_ptr ) from", Table );
		length = StringLen(query);
		mysql_real_query(mysql, query, length);
//		int c = mysql_store_result();
//		Alert("Result", c);
		
		
		
		
		
		
		
		
//		 Query    
		query = StringConcatenate
			(
				"insert into ",
				Table,
				"( date, open, high, low, close ) values (",
				"\'", Year(),"-", Month(), "-", Day(), " ", Hour(), ":", Minute(), ":00", "\',",
				Open[1], ",",
				High[1], ",",
				Low[1],  ",",
				Close[1], ");" 
			);
		length = StringLen(query);
//		 Query
		mysql_real_query(mysql, query, length);
		myerr = mysql_errno(mysql);
		if(myerr > 0)
			Alert( Symbol(), Period(), "Update error =", myerr );	
//		 .		
//		mysql_close(mysql);
	}
}